/**
 * YNAB API Endpoints
 * Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.youneedabudget.com
 *
 * OpenAPI spec version: 1.0.0
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { Configuration } from "./configuration";
import * as CodeGen from "./api";
import { TransactionsApi } from "./transactionsApi";
import utils from "./utils";
export { api as API };
export { utils };
export * from "./api";
/**
 * The YNAB API client
 */
export declare class api {
    protected _configuration: Configuration;
    /**
     *
     * @param accessToken The access token used for authentication
     * @param endpointUrl The API endpoint URL (Optional)
     */
    constructor(accessToken: string, endpointUrl?: string);
    protected _user: CodeGen.UserApi;
    /**
     * /user endpoints interface
     */
    get user(): CodeGen.UserApi;
    protected _budgets: CodeGen.BudgetsApi;
    /**
     * /budgets endpoints interface
     */
    get budgets(): CodeGen.BudgetsApi;
    protected _accounts: CodeGen.AccountsApi;
    /**
     * /budgets/{budget_id}/accounts endpoints interface
     */
    get accounts(): CodeGen.AccountsApi;
    protected _categories: CodeGen.CategoriesApi;
    /**
     * /budgets/{budget_id}/categories endpoints interface
     */
    get categories(): CodeGen.CategoriesApi;
    protected _months: CodeGen.MonthsApi;
    /**
     * /budgets/{budget_id}/months endpoints interface
     */
    get months(): CodeGen.MonthsApi;
    protected _payees: CodeGen.PayeesApi;
    /**
     * /budgets/{budget_id}/payees endpoints interface
     */
    get payees(): CodeGen.PayeesApi;
    protected _payeeLocations: CodeGen.PayeeLocationsApi;
    /**
     * /budgets/{budget_id}/payee_locations endpoints interface
     */
    get payeeLocations(): CodeGen.PayeeLocationsApi;
    protected _transactions: TransactionsApi;
    /**
     * /budgets/{budget_id}/transactions endpoints interface
     */
    get transactions(): TransactionsApi;
    protected _scheduledTransactions: CodeGen.ScheduledTransactionsApi;
    /**
     * /budgets/{budget_id}/scheduled_transactions endpoints interface
     */
    get scheduledTransactions(): CodeGen.ScheduledTransactionsApi;
}
